module SlugTags (slugTags) where

import Text.Pandoc.Definition
import qualified Data.Map.Strict as Map
-- import Text.Pandoc.JSON
import Data.Text (Text)
import Misc

slugTags :: Meta -> Meta
slugTags (Meta m) = Meta $ Map.adjust addSlugs "tags" m

-- | if @tags@ exists and is a list of strings, add the slugs. if it exists and
-- is something else, explode
addSlugs :: MetaValue -> MetaValue
addSlugs (toTextList -> Just tags) = MetaList $ map addSlug1 tags
addSlugs t = error $ "'tags' is\n" <> show t <> "\nwanted a list of strings"

addSlug1 :: Text -> MetaValue
addSlug1 tag = MetaMap $ Map.fromList
  [("name", MetaString tag), ("slug", MetaString $ makeSlug tag)]
